; Initial examples

(setq exampl1
 '(fact-fn (factorial n) +8f +4x +8x (+nx n) mapl right-identity))

(setq examples (append exampl1 examples))

(setq fact-fn
 '(*Y (lambda F (lambda n
		 (if (<= n 1) 1 (* n (F (- n 1)))))))
)

(defun factorial (n)
"factorial n  - returns application of factorial fn to n"
 (list fact-fn n))

(setq +8F
 '(lambda a (lambda b (lambda c (lambda d (lambda e (lambda f
       (lambda g (lambda h (+ a b c d e f g h)))))))))
)

(setq +8R
 '(lambda a (lambda b (lambda c (lambda d (lambda e (lambda f
       (lambda g (lambda h (+ a (+ b (+ c (+ d (+ e (+ f (+ g h)))))))))
   ))))))
)

(setq +8L
 '(lambda a (lambda b (lambda c (lambda d (lambda e (lambda f
       (lambda g (lambda h (+ (+ (+ (+ (+ (+ (+ a b) c) d) e) f) g) h)))
    ))))))
)

(setq +4x '(+ 1 2 3 4))

(setq +8x '(+ 1 2 3 4 5 6 7 8))

(defun +nx (n)
"(+nx n) -- sum of integers 1 ... n"
 (let ((sum nil)) (dotimes (k n) (push (1+ k) sum)) (cons '+ sum))
)

(setq test +4x)

(setq mapl
 '(*Y (lambda M (lambda F (lambda L
     (if (pr L) ((CONS F (M F)) L) L)))))
)

(setq right-identity
 '(exists (x y z u v w a b r s t)
    (and (answer x y z u v w a b r s t)
	 (= x (G r s)) (= y r) (= u s) (= v r) (= w s) (= y a) (= z (H a b))
	 (= v b) (= u (K t)) (= z t) (= w (K t))))
)